## Copyright (C) 2010, 2011 Plexim GmbH. All rights reserverd.
## 
## This file is part of PLECS

function wsout = pleval(wsin, expr, flag)
% disp(wsin)
% disp(expr)
try
    wsout = iAssignEvalAndWho(wsin, expr, flag);
catch
    if (exist('rethrow')~=5)
        error(lasterr)
    else
        rethrow(lasterror)
    end
end



function xwsout = iAssignEvalAndWho(wsin, expr, flag)

% first of all, make a clean slate in the caller workspace
evalin('caller', 'clear');

% next, assign the ws-variables passed via the wsin-struct
vars = fieldnames(wsin);
for idx = 1:length(vars)
    assignin('caller', vars{idx}, getfield(wsin, vars{idx}));
end

if (flag)
    % now evaluate the expression
    evalin('caller', expr);

    % finally, accumulate the wsout-struct
    xwsout = [];
    vars = evalin('caller', 'who');
    for idx = 1:length(vars)
        try
            if ~strcmp(vars{idx}, 'wsout'),
                xwsout = setfield(xwsout, vars{idx}, evalin('caller', vars{idx}));
            end
        catch
        end
    end
else
    xwsout = evalin('caller', expr);
end
